<?php
require_once(WBB_DIR.'lib/data/board/Board.class.php');
require_once(WCF_DIR.'lib/acp/option/OptionTypeSelect.class.php');

/**
 * Option type which provides a board select
 *
 * @package		com.woltlab.community.boardselect
 * @author		WoltLab Community
 * @copyright	2009 WoltLab Community
 * @license		GNU Lesser Public License <http://www.gnu.org/licenses/lgpl.html>
 * @subpackage	acp.option
 * @category	WCF
 */
class OptionTypeBoardSelect extends OptionTypeSelect {
	/**
	 * @see OptionType::getFormElement()
	 */
	public function getFormElement(&$optionData) {
		if (!isset($optionData['optionValue'])) {
			$optionData['optionValue'] = false;
		}
		else {
			$optionData['optionValue'] = explode(',', $optionData['optionValue']);
		}
		// get options
		$options = Board::getBoardSelect(array(), true, true);

		WCF::getTPL()->assign(array(
			'optionData' => $optionData,
			'options' => $options
		));
		return WCF::getTPL()->fetch('optionTypeBoardSelect');
	}
	
	/**
	 * @see OptionType::validate()
	 */
	public function validate($optionData, $newValue) {
		$options = Board::getBoardSelect(array(), true, true);
		if (is_array($newValue)) {
			foreach ($newValue as $key => $value) {
				if(!isset($options[$value])) return FALSE;
			}
		}
		return TRUE;
	}
	
	/**
	 * @see OptionType::getData()	 
	 */
	public function getData($optionData, $newValue) {
		if (is_array($newValue)) {
			return implode(',', $newValue);
		}
		return null;
	}
}
?>